/*
Original Script 
objectMapper.sqf Author: Joris-Jan van 't Land
Edited by armatec

    Description:
    Takes an array of data about a dynamic object template and creates the objects.

    Parameter(s):
    _this select 0: compositions name - "fuelDepot_us"
    _this select 1: Direction in degrees - Number 
    _this select 2: Location to start
    
    Exsample:
    ["fuelDepot_us", 0, getpos player] execVM "Createcomposition.sqf";
*/
_group = createGroup EAST;
_script = _this select 0;
_azi     = round (_this select 1) - 180;
_pos     =  _this select 2;

_objs = [];
_objs = call (compile (preprocessFileLineNumbers format ["comp\%1.sqf",_script]));
private ["_posX", "_posY"];
_posX = floor (_pos select 0);
_posY = floor (_pos select 1);
_newObjs = [];
private ["_multiplyMatrixFunc"];
_multiplyMatrixFunc =
{
    private ["_array1", "_array2", "_result"];
    _array1 = _this select 0;
    _array2 = _this select 1;
    _result =
    [
    (((_array1 select 0) select 0) * (_array2 select 0)) + (((_array1 select 0) select 1) * (_array2 select 1)),
    (((_array1 select 1) select 0) * (_array2 select 0)) + (((_array1 select 1) select 1) * (_array2 select 1))
    ];
    _result
};
for "_i" from 0 to ((count _objs) - 1) do
{
	sleep 0.2;
	private ["_obj", "_type", "_relPos", "_azimuth", "_stance", "_damage", "_newObj", "_vehicleinit"];
        _obj = _objs select _i;
        _type = _obj select 0;
        _relPos = _obj select 1;
        _azimuth = _obj select 2;
        _stance = _obj select 3;
        _damage = _obj select 4;
        _vehicleinit = _obj select 5;
                        
        private ["_rotMatrix", "_newRelPos", "_newPos"];
        _rotMatrix =[[cos _azi, sin _azi],[-(sin _azi), cos _azi]];
        _newRelPos = [_rotMatrix, _relPos] call _multiplyMatrixFunc;
	 private ["_z"];
        if ((count _relPos) > 2) then {_z = _relPos select 2} else {_z = 0};
        _newPos = [_posX + (_newRelPos select 0), _posY + (_newRelPos select 1), _z + 0.1];
	
        private ["_sim"];
	_sim = getText (configFile >> "CfgVehicles" >> _type >> "simulation");
	if (_sim in ["soldier"]) then
		{
			_newObj = _group createUnit [_type, _newpos,[], 0.4, "NONE"];
			_newObj disableAI "move";
			_newObj setPosATL _newPos;
			_newObj setUnitPos _stance;
			_newObj setDir (_azi + _azimuth);
			_newObjs = _newObjs + [_newObj];
		} 
	
	else
	{	
		_sim = getText (configFile >> "CfgVehicles" >> _type >> "simulation");
		if (_sim in ["tankX"]) then
		{
			_groupS = createGroup EAST;
			newObjst = createVehicle [_type, _newpos, [], 0, "NONE"];
			newObjst setVectorUp surfaceNormal position newObjst;
			newObjst setdamage 0;
			newObjst setposATL _newPos;
			newObjst setDir (_azi + _azimuth);
	
			_crew = _groupS createUnit ["O_Soldier_F", _newPos, [],0, "NONE"];
			_crew setformDir (_azi + _azimuth);
			_crew moveinGunner newObjst;
			_newObjs = _newObjs + [_crew];
			_newObjs = _newObjs + [newObjst];
		}
		else
		{
			_newObj = _type createVehiclelocal _newPos;
			_newObj setPosATL _newPos;
			_newObj setDir (_azi + _azimuth);
			_newObjs = _newObjs + [_newObj];
		};
	};
	
       
};  
hint "Done building";

//sleep 3;
//hint "delete";
//{deletevehicle _x} foreach _newObjs;

